'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals

class Backdoor(InteractionObject):
    def __init__(self,ia):
        super(Backdoor,self).__init__(ia)
        self.room = None
        self.count = 0
        self.opened = False
        
    def used(self,item):
        InteractionObject.used(self,item)
        if not self.opened:
            gm = globals.game
            pl = globals.player
            if pl.hasItem("screwdriver"):
                gm.displayText("If I jam the screwdriver in here ...", 2.0)
                gm.scheduleOnce(lambda dt: gm.displayText("It opens!", 1.0), 2.0)
                #gm.scheduleOnce(lambda dt: gm.playSound("unlock"), 2.0)
                
                pl.removeItem("screwdriver")
                self.opened = True
                gm.scheduleOnce(self.activatePortal,3.0)
            elif pl.hasItem("boltcutters"):
                gm.displayText("I need something smaller to jam in the lock.", 4.0)
            else:        
                self.count += 1
                if self.count < 4:
                    gm.displayText("The door is locked",2)
                else:
                    gm.displayText("I need something to force into the lock",4)
                
    def activatePortal(self,dt):
        # TODO: play unlock sound
        
        # then activate the portal
        self.portal.disabled = False
        self.room.activatePortalPlayer(self.portal)

class PileOfPoo(InteractionObject):
    def __init__(self,ia):
        super(PileOfPoo,self).__init__(ia)
        self.inspected = False
        self.msgcount = 0
        self.entermsgs = ["Aww, what's that smell?","Ehh, that reeks...","I think I'm gonna be sick"]
        
    def entered(self):
        InteractionObject.entered(self)
        self.msgcount = min(self.msgcount+1,2)
        globals.game.displayText(self.entermsgs[self.msgcount],4)
        
    def used(self,item):      
        InteractionObject.used(self,item)
        
        gm = globals.game
        pl = globals.player
        
        gm.query(self,["examine pile"])
    
    def notify(self,str):
        gm = globals.game
        pl = globals.player
        
        if str==None:
            gm.displayText("eww, i'm not touching that...")
                        
        if str=="examine pile":
            if not pl.hasItem("gloves"):
                gm.ending("poo")
            else:
                gm.displayText("It's got stripes in it, weird...")      
        
class Back(Room):

    def __init__(self):
        super(Back,self).__init__("The backyard","back.dat")
        self.loadAndSortObjects({'poo':StaticThing("poo.png")})
        self.setInteractionZones({'backdoor':Backdoor,'poo':PileOfPoo})
        
        backdoor = self.getInteractionObject('backdoor')
        backdoor.room = self
        backdoor.portal = self.getPortal(2)
        backdoor.portal.disabled = True
        
            
    
        