'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals

class Desk(InteractionObject):
    def __init__(self,ia):
        super(Desk,self).__init__(ia)
        self.msgcount = 0
        self.locked = True
        self.items = ["stapler","ruler","eraser","handgun"]
        
    def used(self,item):
        InteractionObject.used(self,item)
        gm = globals.game
        pl = globals.player
        
        if self.locked:
            if self.msgcount>5:
                gm.displayText("I guess I can't open it ... yet")
            else:
                gm.displayText("The desk drawer is locked. I wonder what's in there.")
                self.msgcount += 1
        else:
            if len(self.items)>0:
                gm.query(self,["Take "+s for s in self.items],"The drawer opens...")
            else:
                gm.displayText("Nothing is left in there")
    
    def notify(self,str):
        if str and str[:5]=="Take ":
            what = str[5:]
            globals.player.addItem(what)
            self.items.remove(what)

class Bedroom(Room):    
    def __init__(self):
        super(Bedroom,self).__init__("A bedroom","bedroom.dat")
        self.loadAndSortObjects({'bed':StaticThing("bed.png"),'shoes':StaticThing('shoes.png')})
        self.setInteractionZones({'desk':Desk})
            
      