'''
Created on 01/05/2009

@author: ben
'''

import pyglet
from pyglet import gl

class Menu(object):
    "displays a dialog with some options, allows selection, etc..."
    
    def __init__(self,message,options,x,y,width=200,height=400,background=0.75,fontsize=4,headercolour="#FFFFFF"):
        "background = opacity of black background"
        
        self.header = '<font face="BorisBlackBloxx" size="'+str(fontsize)+'" color="'+headercolour+'">'
        if message:
            self.header += message.upper()+"<br />"
        self.header += '<font face="BorisBlackBloxx" size="'+str(fontsize)+'" color="#FFFFFF">'
        self.footer = '</font>'
        self.options = options
        self.width = width
        self.height = height
        self.x = x
        self.y = y
        self.selection = 0
        self.background = background
    
        self.buildDoc()
    
    def buildDoc(self):
        alltext = self.header
        
        for i in range(len(self.options)):
            if i==self.selection:
                alltext += '<strong>' + self.options[i].upper() + '</strong>'
            else:
                alltext += self.options[i].upper()
            alltext += '<br />'
        alltext += self.footer    
        
        self.document = pyglet.text.decode_html(alltext)
        self.layout = pyglet.text.layout.TextLayout(self.document, self.width, self.height, multiline=True)
        self.layout.x = self.x
        self.layout.y = self.y
        self.ch = self.layout.content_height
        self.cw = self.layout.content_width
    
    def up(self):
        self.selection = (self.selection + len(self.options) - 1) % len(self.options)
        self.buildDoc()
        
    def down(self):
        self.selection = (self.selection + 1)%len(self.options)
        self.buildDoc()        
    
    def select(self):
        "returns the selection"
        return self.options[self.selection]
        
    def draw(self, dt):
        border = 10
        bottomleft = (self.layout.x-border,self.layout.y - border + (self.layout.height-self.layout.content_height))
        topright = (self.layout.x + border + self.layout.content_width,self.layout.y + border + self.layout.height)
        
        gl.glColor4f(.5,.5,.5,self.background)
        gl.glRectf(bottomleft[0],bottomleft[1],topright[0],topright[1])
        gl.glColor4f(1,1,1,1)
        self.layout.draw()