'''
Created on 28/04/2009

@author: ben
'''

import pyglet.window.key as KEY
from euclid import *

class Bunch(object):
    def __init__(self, **kwds):
        self.__dict__.update(kwds)

class Dir:
    UP = 0
    DOWN = 1
    LEFT = 2
    RIGHT = 3
    ALL = [UP,DOWN,LEFT,RIGHT]
    
    KEYMAP = {KEY.LEFT:LEFT,KEY.RIGHT:RIGHT,KEY.UP:UP,KEY.DOWN:DOWN}
    
    @staticmethod
    def dirFromKey(key):
        if key in Dir.KEYMAP: return Dir.KEYMAP[key]
        else: return None

poly_intersects_last_line = None
def poly_intersects(polygon,p1,p2):
    "computes if the line joining p1 and p2 intersects the polygon, p1,p2 are Point2"
    global poly_intersects_last_line
    assert isinstance(p1,Point2)
    assert isinstance(p2,Point2)
    
    #l1 = LineSegment2(p1,p2)
    l1 = p1.connect(p2)
    for i in range(len(polygon)):
        ni = (i + 1)%len(polygon)
        p1 = apply(Point2,polygon[i])
        p2 = apply(Point2,polygon[ni])
        #l2 = LineSegment2(p1,p2)
        l2 = p1.connect(p2)
        if l1.intersect(l2):
            poly_intersects_last_line = l2
            return True
    return False
